/*       
isProbablePrime(b),    , 
      b.

   .
-  prime[] -   NPrime  
-     p2<p3, ,  
     p1*p2*p3   p1<p2.
-        level b ,
   (p1*p2*p3).isProbablePrime(b)   .
-       ,
     2.
*/

import java.math.BigInteger;
public class isProba {
  public static BigInteger BI( int v ) { return BigInteger.valueOf(v); }
  public static void wln( String s ) { System.out.println( s ); }
  public static int lk=99;
  /******************************************************************
         p2<p3    p1<p2
    ,  p1*p2*p3 - . 
       ,  0
  ********************************************************************/
  public static BigInteger Carmaikl(BigInteger p2, BigInteger p3) { 
        BigInteger p2m1 = p2.subtract(BI(1));
        BigInteger p3m1 = p3.subtract(BI(1));
   if( p2.gcd(p3m1).compareTo(BI(1)) != 0 ) return( BI(0)); // 
       BigInteger p1 = p2.modInverse(p3m1);         // p1 = 1/p2 mod (p3-1)
       if( p1.compareTo(p2) >= 0 ) return(BI(0));   // p1 >= p2
        // Now: p1 < p2 < p3  and  p1*p2 = 1 ( mod p3m1 )
       if( ! p1.isProbablePrime(lk) ) return( BI(0) );
       if( p1.multiply(p3).mod(p2m1).compareTo(BI(1)) != 0 ) return( BI(0) );
        // p1*p3 != 1 mod (p2m1)
        return p1;
  }


  /******************************************************************
        a 
      b , 
    a.isProbablePrime(b) == false.
  ********************************************************************/
  public static  int min_b( BigInteger a) {
    int b;
    for( b=0; b<=lk; b++ ) 
      if( !a.isProbablePrime(b) ) return b;
    return -1; //   , ..    
               //    ,  -1
    } 
 
  /******************************************************************/
  public static void main(String[] args){ 
    int l=0;
    int NPrime = 600;             //   
    int prime[] = new int[NPrime];  //   
    int level_[]=new int[lk+1];
    BigInteger car[]=new BigInteger[600];
    int k = 3;   // ,       
    for (int i=0;i<NPrime-1;k+=2) 
        if ( BI(k).isProbablePrime(lk) ) prime [++i]=k;
    wln( "prime are ready");  //    prime 
    //  -     
    BigInteger min_p = BI(3);
    for (int i=NPrime-1; i>=2; i--) {
       BigInteger p3 = BI(prime[i]) ;
       for (int j=i-1; j>=1; j--) { 
          BigInteger p2 = BI(prime[j]);
          BigInteger p1 = Carmaikl(p2,p3);
          if ( p1.compareTo(min_p) >0 )   
                //  p1*p2*p3 -    p1>min_p
             if ((p1.multiply(p2.multiply(p3))).compareTo(BI(999999999))<0)  
                 //     4-9    
                 car[++l]=p1.multiply(p2.multiply(p3));
          }
       }
    System.out.println("Amount of numbers Carmichael = "+ l);
    for (int round=1; round<1001;round++) 
       for (int i=1;i<=l;i++) {
             BigInteger vr=car[i];
             int level = min_b( vr);
             if (level<3) continue;   //    
                 level_[level]++;   //  
       }
    //      
    wln("Results:");
    for (int i=3; i<=lk; i++)
       if (level_[i]>0)
           System.out.println("level = "+(i-1)+" ; probability = "+ 
               (float) level_[i]/1000/l);
  }
}
